#if !defined(_CPRIMITIVE_H)
#define _CPRIMITIVE_H
/* Shaderprogramozs - Grafika s jtkfejleszts DirectX-szel ----------------

	llomny          : CPrimitive.h

    Nyelv             : C++

    Ltrehozs dtuma : 2008.08.28

    Utols mdosts  : 2009.03.15

    Lers            : Shaderprogramozs
						Grafika s jtkfejleszts DirectX-szel
						11.4. Sznes geometria megjelentse
						305. oldal

               Copyright (C) Nyisztor Kroly 2008-2009
							www.directx.hu
-----------------------------------------------------------------------------*/
/*- Befordtott fejllomnyok -------------------------------------------*/
#include <d3d9.h>
#include <d3dx9.h>

#include "..\..\include\IRenderable.h"
#include <string>
using std::string;


/*- Nvterek ----------------------------------------------------------------*/
namespace app
{
namespace scene
{
/*- Defincik s konstansok ------------------------------------------------*/

/*- Sajt tpusok s osztlyok -----------------------------------------------*/
class CPrimitive : public IRenderable
{
private:
	LPDIRECT3DDEVICE9 myD3DDevicePtr;

	D3DXMATRIX myWorldMat;

	const string myFXFile;
	
	ID3DXEffect* myEffectPtr;
	D3DXHANDLE   myWireframeHandle;
	D3DXHANDLE   myFilledTechHandle;
	D3DXHANDLE   myHWVP;

	struct SVertexPosCol
	{
		D3DXVECTOR3 pos;	// cscspont koordinta
		D3DCOLOR	col;	// cscspont szne
	};
	// vertex adatinterfsz
	IDirect3DVertexDeclaration9* myDeclPtr;

	LPDIRECT3DVERTEXBUFFER9 myTriangleListVBPtr;

	bool myFaultFlag;

private:
	bool initVertexDeclaration();
	bool initVertexBuffers();
	bool loadFX();
public:
	//CPrimitive();
	CPrimitive( const string& fxFileName_in,
				const D3DXVECTOR3& posVec_in = D3DXVECTOR3(0,0,0), 
				const D3DXVECTOR3& rotVec_in = D3DXVECTOR3(0,0,0), 
				const D3DXVECTOR3& scaleVec_in = D3DXVECTOR3(1,1,1) );
				  
	virtual ~CPrimitive();
	
	virtual void update( float dt ) {};
	
	virtual void render();
	/** lostDev esemny kezelse */
	virtual void onLostDevice();
	/** resetDev esemny kezelse */
	virtual void onResetDevice();

	bool hasErrors()
	{
		return myFaultFlag;
	}
};
} // scene
} // app

#endif  //_CPRIMITIVE_H
