#if !defined(_CAMBIENTLITMESHNODE)
#define _CAMBIENTLITMESHNODE
/* Shaderprogramozs - Grafika s jtkfejleszts DirectX-szel ----------------

	llomny          : CAmbientLitMeshNode.h

    Nyelv             : C++

    Ltrehozs dtuma : 2008.12.26

    Utols mdosts  : 2009.03.15

    Lers            : Shaderprogramozs
						Grafika s jtkfejleszts DirectX-szel
						11.6.1. "ltalnos httrmegvilgts"
						323. oldal

               Copyright (C) Nyisztor Kroly 2008-2009
							www.directx.hu
-----------------------------------------------------------------------------*/

/*- Befordtott fejllomnyok -------------------------------------------*/
#include <d3d9.h>
#include <d3dx9.h>

#include <string>
using std::string;

#include "..\..\include\IRenderable.h"

/*- Nvterek ----------------------------------------------------------------*/
namespace app
{
/*!
 * \brief jtkszntr nvtere
 * 
 * \see
 * 	
 */
namespace scene
{
/*- Defincik s konstansok ------------------------------------------------*/
class BaseMesh;
/*- Sajt tpusok s osztlyok -----------------------------------------------*/
/*!
 * \brief  Az  NPC-k (non-playable characters) osztlya
 * Pldul bolygkat, holdakat stb. hoz ltre
 * 
 * \remarks Alfa-layeres, felhzetet utnz gmb hozzrendelsvel egy textrzott bolyghoz 
 * s nmi animcival lgkrrel rendelkez bolygk hozhatk ltre 
 * \author Nyisztor Kroly
 * \date 2008 - 2008
 * \see
 */
class CAmbientLitMeshNode : public IRenderable
{
protected:
	LPDIRECT3DDEVICE9 myD3DDevicePtr;

	BaseMesh* myMeshPtr;
	
	D3DXMATRIX myWorldMat;
	D3DXMATRIX myScaleMat;
	D3DXMATRIX myRotMat;
	D3DXMATRIX myTranslMat;

	const string myFXFile;

	D3DXVECTOR3 myPosVec;
	D3DXVECTOR3 myRotVec;
	D3DXVECTOR3 myScaleVec;

	ID3DXEffect* myEffectPtr;
	D3DXHANDLE   mhTech;
	D3DXHANDLE   myHWVP;
	
	D3DXHANDLE  myHAmbientMaterialColor;
	D3DXHANDLE 	myHAmbientLightColor;
	
	D3DXCOLOR myAmbientMat;
	D3DXCOLOR myAmbientLight;

	struct SVertexPos
	{
		D3DXVECTOR3 pos;
	};
	
	// vertex adatinterfsz
	IDirect3DVertexDeclaration9* myDeclPtr;
	
private:
	HRESULT initVertexDeclaration();
	HRESULT loadFX();
public:
	//CAmbientLitMeshNode();
	CAmbientLitMeshNode( const string& fxFileName_in, 
				  const string& meshFile_in,
				  const D3DXVECTOR3& posVec_in = D3DXVECTOR3(0,0,0), 
				  const D3DXVECTOR3& rotVec_in = D3DXVECTOR3(0,0,0), 
				  const D3DXVECTOR3& scaleVec_in = D3DXVECTOR3(1,1,1) );
				  
	virtual ~CAmbientLitMeshNode();
	
	virtual void update( float dt );
	
	virtual void render();
	/** lostDev esemny kezelse */
	virtual void onLostDevice();
	/** resetDev esemny kezelse */
	virtual void onResetDevice();

	const D3DXMATRIX& getWorldMat();	
};
} // scene
} // app

#endif  //_CAMBIENTLITMESHNODE
