/* ----------------------------------------------
	Nyisztor Kroly
	Shader programozs
	Grafika s jtkfejleszts DirectX-szel II
	
	FX fjl	: NPR.fx
	Lers	: modell rajzfilmszer megjelentse
	Lsd	: 11.9.1. Rajzfilmszeru megjelents
			  393. oldal
------------------------------------------------- */
uniform extern float4x4 gWorld;
uniform extern float4x4 gWorldViewProjection;
uniform extern float4 gAmbientMaterialColor;
uniform extern float4 gDiffuseMaterialColor;
uniform extern float4 gLightColor;
uniform extern float3 gLightPos;

uniform extern texture gTexToonShades;

sampler SamplerToonTex = sampler_state
{
	Texture = <gTexToonShades>;
	MinFilter = POINT;
	MagFilter = POINT;
	AddressU  = WRAP;
    AddressV  = WRAP;
};

struct VS_OUTPUT
{
    float4 PositionProj : POSITION0;
	float2 Tex0			: TEXCOORD0;
	float4 DiffuseColor	: COLOR0;
};
// cscspont rnyal
VS_OUTPUT vs_main(float3 posLocal_in : POSITION0, 
				  float3 normalLocal_in : NORMAL0)
{
    // eredmny struktra kinullzsa
	VS_OUTPUT outVS = (VS_OUTPUT)0;
	// cscspont helyzet transzformci vgrehajtsa
	outVS.PositionProj = mul(float4(posLocal_in, 1.0f), gWorldViewProjection);
	
	// fnyvektor kiszmtsa
	float3 posW = mul(float4(posLocal_in, 1.0f), gWorld).xyz;
	float3 lightVecW = normalize( gLightPos - posW );
	// felleti normlvektor transzformlsa modelltrbl a vilg-koordintarendszerbe
	float3 normalW = mul(float4(normalLocal_in, 0.0f), gWorld).xyz;	
	// fnyintenzits kiszmtsa a Lambert-fle koszinusz fggvnnyel
	float i_diffuse = max(dot(lightVecW, normalW), 0.0f);
	// index az 1 dimenzis rnyalatokat tartalmaz textrba
	outVS.Tex0 = float2(i_diffuse, 0.0f);
	// a diffz szn kiszmtsa
	outVS.DiffuseColor = i_diffuse * ( gDiffuseMaterialColor * gLightColor);	
	// a kitlttt struktra visszatrtse
    return outVS;
}

// kppont rnyal
float4 ps_main(float2 tex0_in : TEXCOORD0, 
			   float3 diffuse_in : COLOR0) : COLOR
{
	float3 texColor = tex2D(SamplerToonTex, tex0_in).rgb;
	// kimeneti struktra feltltse
	return float4( (diffuse_in * 1.5f) + (texColor * 0.2f), gDiffuseMaterialColor.a );    
}

technique NPRTech
{
    pass P0
    {
        // a P0 lps cscspont- s kppontrnyalja
        vertexShader = compile vs_2_0 vs_main();
        pixelShader  = compile ps_2_0 ps_main();
    }
}