#if !defined( SKYSPHERE_H )
#define SKYSPHERE_H
/* Shaderprogramozs - Grafika s jtkfejleszts DirectX-szel ----------------

	llomny          : CCubeTex.h

    Nyelv             : C++

    Ltrehozs dtuma : 2009.03.03

    Utols mdosts  : 2009.03.15

    Lers            : Shaderprogramozs
						Grafika s jtkfejleszts DirectX-szel
						11.9.3. "Krnyezeti trkp"
						404. oldal

               Copyright (C) Nyisztor Kroly 2009
							www.directx.hu
-----------------------------------------------------------------------------*/

/*- Befordtott fejllomnyok -----------------------------------------------*/
#include <d3d9.h>
#include <d3dx9.h>

#include <string>
using std::string;

#include "..\..\include\IRenderable.h"

/*- Nvterek ----------------------------------------------------------------*/
namespace app
{
namespace scene
{

/*- Defincik s konstansok ------------------------------------------------*/

/*- Sajt tpusok s osztlyok -----------------------------------------------*/
class CCubeTex : public IRenderable
{
// adattagok
private:
	LPDIRECT3DDEVICE9  myD3DDevicePtr;
	ID3DXMesh* myCubePtr;
	float myRadius;
	IDirect3DCubeTexture9* myCubeTexPtr;
	ID3DXEffect* myEffectPtr;
	D3DXHANDLE myHTech;
	D3DXHANDLE myHCubeMap;
	D3DXHANDLE myHWVP;	
	D3DXHANDLE myHCamPos;

	const string myFXFile;
	const string myTexFile;

	struct SVertexPT
	{
		D3DXVECTOR3 pos;
		D3DXVECTOR2 tex0;
	};

	IDirect3DVertexDeclaration9* myDeclPtr;

private:
	HRESULT init3DTex();
	HRESULT initVertexDeclaration();
	HRESULT loadFX();

// tagfggvnyek
public:
	// konstruktor
	CCubeTex( const string& fxFileName_in, const string& textureFile_in, const float cubeDim_in );
	// destruktor
	~CCubeTex();

	virtual void update( float dt );
	virtual void render();
	virtual void onLostDevice();
	virtual void onResetDevice();

private:
	// elrejtjk a copy ctor-t s az rtkad opertort, 
	// megakadlyozva ezzel az objektumok msolst
	CCubeTex( const CCubeTex& );
	CCubeTex& operator =( const CCubeTex& );
	
};
} // namespace scene
} // namespace app

#endif