﻿#if !defined(_IRENDERABLE_H)
#define _IRENDERABLE_H
/*[ Fordítási egység ----------------------------------------------------------
    Név               : IRenderable.h

    Nyelv             : C++

    Létrehozás dátuma : 2008.08.26

    Utolsó módosítás  : 2008.08.26

    Leírás            : megjeleníthető típusok interfésze

	Copyright (C) Nyisztor Károly 2008-2008
-----------------------------------------------------------------------------*/

/*- Befordított fejállományok -------------------------------------------*/

/*- Névterek ----------------------------------------------------------------*/
namespace app
{
/*!
 * \brief a megjeleníthető osztályok interfésze; a megvalósítandó függvényeket deklarálja
 * 
 * \remarks minden megjelenítésre szánt osztályt ebből az interfészből származtassunk
 * 
 * \see
 * 	
 */
namespace scene
{
/*- Definíciók és konstansok ------------------------------------------------*/

/*- Saját típusok és osztályok -----------------------------------------------*/
/*!
 * \brief  
 * 
 * \remarks 
 * 
 * \author Nyisztor Károly
 * \date 2008 - 2008
 * \see
 */
class IRenderable
{
public:
	//IRenderable();
	IRenderable() {};
	  
	virtual ~IRenderable() {};
	
	virtual void update( float dt ) = 0;
	
	virtual void render() = 0;
	/** lostDev esemény kezelése */
	virtual void onLostDevice() = 0;
	/** resetDev esemény kezelése */
	virtual void onResetDevice() = 0;
};
} // scene
} // app

#endif  //_IRENDERABLE_H
